<?php

require_once( RAFFLE_PLAY_WOO_DIR_PATH . '/includes/RafflePlayWoo_Includes.php');

class RafflePlayWoo_Front{

    public static function drp_reports_html( $settings ){

        RafflePlayWoo_Includes::rpwoo_loading_screen();

        
        $date_format = array(
            'dd/mm/yyyy',
            'yyyy/mm/dd',          
            'dd-mm-yyyy',
            'yyyy-mm-dd',
            'dd/mm/yy',           
            'dd-mm-yy',           
            'yy/mm/dd',           
            'yy-mm-dd'            
        );
        
        ?>
            <div class='wrap drp-reports'>
                <div class="container-fluid ">
                    <form method="POST" >
                        <div class="panel panel-default" id='panel_reports'>
                            <div class="panel-heading">                  
                                <h4 class='d-inline'> <?php esc_html_e('Reports', RAFFLE_PLAY_WOO_DOMAIN);?></h4>
                                <span class='d-inline'> <?php esc_html_e('(live data)', RAFFLE_PLAY_WOO_DOMAIN);?></span>   
                                <?php RafflePlayWoo_Includes:: rpwoo_premium_link(); ?>                                           
                            </div>
                            <p></p>

                            <div class="panel-body">
                                <div class='bmp-set-row' >

                                        <div id="div_order_raffles" >
                                            <h5> <b> <?php esc_html_e('Raffle', RAFFLE_PLAY_WOO_DOMAIN);?> </b> 
                                                <?php
                                                    echo RafflePlayWoo_Includes::rpwoo_create_dropdown( $settings['raffles'], 'raffles_list' );                                                                                      
                                                ?>
                                            </h5>
                                            
                                           
                                        </div>

                                        <div >
                                            <div style='display: inline-block;' >
                                                <label for="drp_date_from" >  <?php esc_html_e('From Date', RAFFLE_PLAY_WOO_DOMAIN); ?></label>
                                                <input type='text' disabled name="drp_date_from" class='input-dates' id="drp_date_from" />
                                                
                                            </div>

                                            <div style='display: inline-block;' >
                                                <label for="drp_date_to" >  <?php esc_html_e('To', RAFFLE_PLAY_WOO_DOMAIN); ?></label>
                                                <input type='text' name="drp_date_to" class='input-dates' disabled id="drp_date_to" />                                               
                                            </div>

                                            <button class='button button-secondary' id="rpr_clear_dates">
                                                <i class="fa fa-broom" title="<?php esc_html_e('Clear Dates', RAFFLE_PLAY_WOO_DOMAIN); ?>"></i>
                                            </button>
                                          
                                        </div>

                                        <p></p>
                                         
                                        <label for="drp_radio_sales_day">
                                            <input type='radio' checked name="drp_radio_report" disabled value='1' id="drp_radio_sales_day" />
                                            <?php esc_html_e('Daily Sales', RAFFLE_PLAY_WOO_DOMAIN); ?>
                                            <?php RafflePlayWoo_Includes:: rpwoo_premium_image(); ?>
                                        </label>
                                        <p></p>  

                                        <label for="drp_radio_sales_weekly">
                                            <input type='radio'  name="drp_radio_report" value='2' disabled id="drp_radio_sales_weekly" />
                                            <?php esc_html_e('Weekly Sales', RAFFLE_PLAY_WOO_DOMAIN); ?>                                        
                                            <?php echo '<i> '; esc_html_e('(Monday to Sunday)', RAFFLE_PLAY_WOO_DOMAIN); echo '</i>' ?>
                                            <?php RafflePlayWoo_Includes:: rpwoo_premium_image(); ?>
                                        </label>
                                        <p></p>  

                                        <label for="drp_radio_sales_monthly">
                                            <input type='radio'  name="drp_radio_report" value='3' disabled id="drp_radio_sales_monthly" />
                                            <?php esc_html_e('Monthly Sales', RAFFLE_PLAY_WOO_DOMAIN); ?>
                                            <?php RafflePlayWoo_Includes:: rpwoo_premium_image(); ?>
                                        </label>
                                        <p></p>     

                                        <label for="drp_radio_sales_region">
                                            <input type='radio' name="drp_radio_report" disabled value='4' id="drp_radio_sales_region"/>
                                            <?php esc_html_e('Sales by Region/County', RAFFLE_PLAY_WOO_DOMAIN); ?>
                                            <?php RafflePlayWoo_Includes:: rpwoo_premium_image(); ?>
                                        </label>                                    
                                        <p></p>

                                        <label for="drp_radio_sales_country">
                                            <input type='radio' name="drp_radio_report" disabled value='5' id="drp_radio_sales_country"/>
                                            <?php esc_html_e('Sales by Country&County', RAFFLE_PLAY_WOO_DOMAIN); 
                                                echo "<span class='spacer'></span>";
                                                echo "<select name='country_selected' id='countries_list'>";
                                                echo "<option value='all'>". esc_html__('All', RAFFLE_PLAY_WOO_DOMAIN ) . "</option>";

                                                foreach( $settings['countries'] as $key=>$country ){
                                                    $selected = '';
                                                    if( $key == $settings['base_country'] ){
                                                        $selected = 'selected';
                                                    }
                                                    echo "<option {$selected} value='{$key}'> {$country} </option>";
                                                }  

                                                echo "</select>";                                               
                                                
                                            ?> 
                                             <?php RafflePlayWoo_Includes:: rpwoo_premium_image(); ?>
                                        </label>   
                                        <br/>              
                                        <label style="margin-left: 75px; margin-top: 10px;" for="other_countries">
                                                <?php 
                                                    esc_html_e( ' Include the rest of the Countries ', RAFFLE_PLAY_WOO_DOMAIN );
                                                ?>
                                                <input type="checkbox" name="group_country" id="other_countries" />
                                           
                                                <?php esc_html_e( '(grouped by country)'); ?>
                                        </label>                   
                                        <p></p>

                                        <label for="drp_radio_sales_ticket">
                                            <input type='radio' disabled name="drp_radio_report" value='6' id="drp_radio_sales_ticket" /> 
                                            <?php esc_html_e('Sales by Product', RAFFLE_PLAY_WOO_DOMAIN); ?> 
                                            <?php RafflePlayWoo_Includes:: rpwoo_premium_image(); ?>
                                        </label>
                                        <p></p>   

                                        <label for="drp_radio_raffle_ticket">
                                            <input type='radio' disabled name="drp_radio_report" value='7' id="drp_radio_raffle_ticket" /> 
                                            <?php esc_html_e('By Raffle Ticket '); ?> 
                                            <button onclick='return false;' class='button button-primary' id='btn_modal_fields'> <?php esc_html_e('Export Columns', RAFFLE_PLAY_WOO_DOMAIN); ?> </button>
                                            <?php RafflePlayWoo_Includes:: rpwoo_premium_image(); ?>
                                        </label>
                                        <p></p>     

                                        <input type="hidden" value='0' name="rpr_product_sale" id='rpr_product_sale' />
                                        <input type="hidden" value='' name="rpr_report_four_cols_sel" id='report_four_cols_sel' />
                                        <input type="hidden" value='' name="rpr_report_four_cols_ava" id='report_four_cols_ava' />
                                        <input type="submit" class='button button-primary' id="btn_send_report" value="<?php esc_html_e('Go', RAFFLE_PLAY_WOO_DOMAIN);?>" />
                                        <input type="hidden" name="rpr_report_order_status" value='' />
                                        <?php wp_nonce_field( 'nonce_field_form_rpr', 'nonce_field_form_rpr' ); ?>
                                
                                </div>

                                <div class='row bmp-set-row' >
                
                                </div>
                            
                            </div> 

                        </div> 

                        <div class='panel panel-default' id='panel_settings'>
                            <div class="panel-heading">
                            <h4> <?php esc_html_e('Report Settings', RAFFLE_PLAY_WOO_DOMAIN);?></h4>  
                            </div>

                            <div class="panel-body">
                                <div id='div_custom_currency'>
                                    <label for="input_custom_currency">
                                        <?php esc_html_e('Custom Currency Symbol', RAFFLE_PLAY_WOO_DOMAIN);?>
                                        <input type='text' style="width: 50px;" max='5' disabled name='input_custom_currency' id='input_custom_currency'  value="<?php echo htmlspecialchars_decode( $settings['custom_currency']);?>" /> 
                                        <i> (<?php esc_html_e('If empty, use woocommerce currency', RAFFLE_PLAY_WOO_DOMAIN);?>)</i>
                                        <?php RafflePlayWoo_Includes:: rpwoo_premium_image(); ?>
                                    </label>
                                </div>
                                <div id="div_order_status" >
                                    <h5> <b> <?php esc_html_e('Order Status ', RAFFLE_PLAY_WOO_DOMAIN);?> </b> </h5>
                                    <?php

                                        foreach( $settings['statuses'] as $key=>$value ){
                                            $checked = '';
                                            if( in_array( $key, $settings['saved_statuses']) )
                                                $checked = 'checked';
                                            echo "<label style='margin-right: 10px;'> <input disabled {$checked} id='{$key}' type='checkbox' /> {$value}  </label> <span> </span>";
                                        }
                                                                            
                                        RafflePlayWoo_Includes:: rpwoo_premium_image(); 
                                    ?>
                                </div>


                                <div id="div_order_filter" >
                                    <h5> <b> <?php esc_html_e('Running Multiple Raffles at the same time', RAFFLE_PLAY_WOO_DOMAIN);?> </b>                                         
                                    </h5>
                                    <h6> (<?php esc_html_e('Order has mixed raffle products', RAFFLE_PLAY_WOO_DOMAIN);?> )</h6>
                                 
                                    <input type="checkbox" data-toggle='toggle' checked  disabled  name="order_filter" id="order_filter_product"
                                        data-on='<?php esc_html_e('Product', RAFFLE_PLAY_WOO_DOMAIN); ?>' data-off='<?php esc_html_e('Order', RAFFLE_PLAY_WOO_DOMAIN); ?>'
                                    /> <?php esc_html_e('Get Sale By Product', RAFFLE_PLAY_WOO_DOMAIN) ?>
                                    <?php RafflePlayWoo_Includes:: rpwoo_premium_image(); ?>                                   
                                </div>


                            </div>
                            <input type="hidden" name="hidden_order_status" id='hidden_order_status' value=''>
                        </div>
                    </form>
                </div> <!-- /container-fluid -->
            </div> <!-- /wrap -->

            <div id="modal_fields" class="modal-rpr">

                <!-- Modal content -->
                <div class="rpwoo-modal-content">                   
                
                    <p class='info_col_fields'>*** <?php esc_html_e('Drag & drop to remove from Report Columns', RAFFLE_PLAY_WOO_DOMAIN);?> ***</p>
                    <p class='info_col_fields'>*** <?php esc_html_e('Order can be changed by dragging to desired position number', RAFFLE_PLAY_WOO_DOMAIN);?> ***</p>            
                    <div class="rpwoo-modal-body">                                   
                        <div class="" id="div_report_fields">
                            <h3> <?php esc_html_e('Report Columns', RAFFLE_PLAY_WOO_DOMAIN);?></h3>
                            <ul id="ul_report_fields" class="connectedSortable">                                
                            </ul>
                        </div>                      
                        <p id='div_middle'></p>
                        <div class="" id="div_fields">
                            <div class='ul-header' style='display: inline-block'>
                                <h3 style='display: inline-block'> <?php esc_html_e('Available Columns', RAFFLE_PLAY_WOO_DOMAIN);?></h3>
                                <a class="nav-item nav-link active text-primary btn-add-col" style='width: 25px; display: inline-block' href="#">                              
                                    <i class="fa fa-plus-square"></i>   
                                </a>
                                <div id='div_new_column' style='width: 270px; height: 250px; background: #DCDCDC; position: absolute; display: none;'>
                                   <p style='padding: 4px'> <?php esc_html_e( 'Col Text', RAFFLE_PLAY_WOO_DOMAIN ); ?> <input type="text" name="" id="new_col_name">     </p>
                                   <p style='padding: 4px' >  <?php esc_html_e( 'DB Meta Name', RAFFLE_PLAY_WOO_DOMAIN ); ?> 
                                        <input type="text" name="" id="db_col_name">  </p>
                                   <p class='text-danger' style='padding: 4px' > 
                                     <?php esc_html_e('DB  Name  is going to be extracted from the order metadata. (E.g. Data captured at checkout)', RAFFLE_PLAY_WOO_DOMAIN ); ?> 
                                     <?php esc_html_e('Invalid chars (<,>,&,%,\',")', RAFFLE_PLAY_WOO_DOMAIN); ?>
                                   </p>

                                    <p></p>    
                                    <p></p>
                                    <p></p>

                                    <div class="div-footer" style='position: absolute; top:212px; left: 148px' >    
                                        <button class='button button-secondary btn-cancel-col'> <?php esc_html_e('Cancel', RAFFLE_PLAY_WOO_DOMAIN ); ?> </button>
                                        <button class='button button-primary btn-save-col'> <?php esc_html_e('Add', RAFFLE_PLAY_WOO_DOMAIN ); ?> </button>
                                    </div>
                                </div>
                            </div>
                            <ul id="ul_available_fields" class="connectedSortable">                         
                            </ul>
                        </div>     
        
                    </div>
                  
                    
                    <div class="rpwoo-modal-footer">
                        <button id='btn_close_modal' class='button button-primary'> <?php esc_html_e('OK', RAFFLE_PLAY_WOO_DOMAIN); ?> </button>    
                         <i> <?php esc_html_e('(In order to save the column changes, run this report)', RAFFLE_PLAY_WOO_DOMAIN );?>  </i>
                    </div>
                </div>


            </div>

            <script>
                var s_rpr_raffle_ticket_no  = "<?php esc_html_e('Raffle Ticket No', RAFFLE_PLAY_WOO_DOMAIN);?>";
                var s_rpr_order_no          = "<?php esc_html_e('Order No', RAFFLE_PLAY_WOO_DOMAIN);?>";
                var s_rpr_order_total       = "<?php esc_html_e('Order Total', RAFFLE_PLAY_WOO_DOMAIN);?>";
                var s_rpr_first_name        = "<?php esc_html_e('First Name', RAFFLE_PLAY_WOO_DOMAIN);?>";
                var s_rpr_last_name         = "<?php esc_html_e('Last Name', RAFFLE_PLAY_WOO_DOMAIN);?>";
                var s_rpr_address_one       = "<?php esc_html_e('Address One', RAFFLE_PLAY_WOO_DOMAIN);?>";
                var s_rpr_address_two       = "<?php esc_html_e('Address Two', RAFFLE_PLAY_WOO_DOMAIN);?>";
                var s_rpr_city              = "<?php esc_html_e('City', RAFFLE_PLAY_WOO_DOMAIN);?>";
                var s_rpr_post_code         = "<?php esc_html_e('Post Code', RAFFLE_PLAY_WOO_DOMAIN);?>";
                var s_rpr_country           = "<?php esc_html_e('Country', RAFFLE_PLAY_WOO_DOMAIN);?>";
                var s_rpr_county            = "<?php esc_html_e('County', RAFFLE_PLAY_WOO_DOMAIN);?>";
                var s_rpr_email             = "<?php esc_html_e('Email', RAFFLE_PLAY_WOO_DOMAIN);?>";
                var s_rpr_phone             = "<?php esc_html_e('Phone', RAFFLE_PLAY_WOO_DOMAIN);?>";
                var s_rpr_order_status      = "<?php esc_html_e('Order Status', RAFFLE_PLAY_WOO_DOMAIN);?>";
                var s_rpr_order_date        = "<?php esc_html_e('Order Date', RAFFLE_PLAY_WOO_DOMAIN);?>";
                var custom_cols_sel         = <?php echo $settings['custom_cols'];?>;
                var custom_cols_ava         = <?php echo $settings['custom_cols_ava'];?>;

                var woo_countries           = <?php echo json_encode( $settings['countries'] );?>;     
                                       
            </script>

        <?php

    }


}