(function($){
    "use strict";
    $(document).ready(function(){
        //save setting ajax
        const DRP_SAVE_ACTION = 'drp_save_settings';        
        var original_ticket_start_count_at = parseInt( $('#rdp_ticket_start_count_at').val() );
        var original_live_val              = ( $('#rdp_life_raffle').prop('checked') ? 1 : 0 );        
        
        $('.rdp_save_settings').on('click', function(e){
            e.preventDefault();
            let obj = {};
            let data = {};
            data.ticket_count_starts_at = parseInt( $('#rdp_ticket_start_count_at').val() );
            data.live_raffle            = ( $('#rdp_life_raffle').prop('checked') ? 1 : 0 ); 
            data.email_header           = $.trim( $('#rpwoo_email_header_lbl').val() );
            data.email_body             = $.trim( $('#rpwoo_email_body_lbl').val() );   
            data.ticket_prefix          = $.trim( $('#rpwoo_ticket_prefix').val() ); 
            data.limit_tickets          = ( $('#radio_limit_raffle_yes').prop('checked') ? 1 : 0 );
            data.limit_tickets_no       = parseInt( $('#limit_raffle_no_tickets').val() );

            data.start_date             = $.trim( $('#rpwoo_start_date').val() );
            data.end_date               = $.trim( $('#rpwoo_end_date').val() );

            data.start_time             = $.trim( $('#rpwoo_start_time').val() );
            data.end_time               = $.trim( $('#rpwoo_end_time').val() );
            data.email_extra            = $.trim( $('#rpwoo_email_body_extra_txt').val() );
            data.email_pos              = $('input:radio[name="rpwoo_email_data_pos"]:checked').val();  
            data.terminated             = $('#rdp_terminate_raffle').prop('checked') ? 'yes' : 'no';  

            data.msg_terminate          = $.trim( $('#msg_terminate').val() );
            data.msg_startdate          = $.trim( $('#msg_startdate').val() );
            data.msg_enddate            = $.trim( $('#msg_enddate').val() );
            data.msg_will_enddate       = $.trim( $('#msg_will_enddate').val() );
            data.msg_add_to_cart        = $.trim( $('#msg_add_to_cart').val() );
            data.msg_add_to_cart_ex     = $.trim( $('#msg_add_to_cart_ex').val() );
            data.msg_update_cart_ex     = $.trim( $('#msg_update_cart_ex').val() );
            data.raffle_name            = $.trim( $('#rpwoo_raffle_name').val() );
            data.inc_name               = $('#rpwoo_inc_name').prop('checked') ? 1 : 0;
            data.limit_order_per_raffle = $('#limit_order_per_raffle').prop('checked') ? 1 : 0;
            data.limit_order_per_raffle_txt = $.trim( $('#limit_order_per_raffle_txt').val() );
        
            if ( isNaN( data.limit_tickets_no ))
               data.limit_tickets_no = 0;
            else if ( data.limit_tickets_no < 0 )
               data.limit_tickets_no = 0;
            
            if( $('#rpwoo_resolved_issues').length > 0 ){
                if( $('#rpwoo_resolved_issues').prop('checked') ){
                    data.mark_issues = true;
                }
            }

            obj.action = DRP_SAVE_ACTION;
            obj.data = data;
            bmp_save_setting_ajax( obj  );
        });
      
        $('#rpwoo_ticket_prefix').on('keydown', function(){
            let input_val = $.trim( $(this).val() );
            if( input_val.length > 15 ){
                $( this ).val( input_val.substring( 0, 15 ) );
            }
        });      

        $( "#rpwoo_start_date, #rpwoo_end_date" ).datepicker({
            yearRange : '2018:' + ( (new Date()).getFullYear() + 4),
            dateFormat : 'dd-mm-yy',
            changeMonth: true, 
            changeYear: true
        });

        if( $('#rpwoo_db_health').length > 0 ){
            $('#rpwoo_db_health').on('click', function(){
                rpwoo_fixDB();
            });
        }

        $('#radio_limit_raffle_no').on('change', function(){
            if( $( this ).prop('checked') ){
                $('#limit_raffle_no_tickets').prop('readonly', true );
            }
        });

        $('#radio_limit_raffle_yes').on('change', function(){
            if( $( this ).prop('checked') ){
                $('#limit_raffle_no_tickets').prop('readonly', false );
            }
        });

        if( $('#radio_limit_raffle_no').prop('checked'))
            $('#limit_raffle_no_tickets').prop('readonly', true ); 

    

        $('.clockpicker_main').clockpicker({           
            autoclose : true          
        });

        
        $('[data-toggle="tooltip"]').tooltip({
           selector: false,
           trigger : 'hover'
        });

    
    //    $('[data-toggle="tooltip"]').tooltip();  
    });

    function bmp_save_setting_ajax( $obj, $callback ){
        $('#drpLoaderImg').show();
        var data_ajax = {
            action: $obj.action,
            type: 'POST',
            data: $obj.data,
            dataType: 'json', 
            contentType: 'application/json'
        }
        
        $.ajax({
            type: 'POST',
            url: ajaxurl,
            data: data_ajax,
            beforeSend: function(){              

              if( typeof $callback !== 'undefined'){
                  $callback();
              }
            }, 
            success: function(data){
                //should display a success/error message
            
                try {
                    data = JSON.parse( data );                  
                    let lRec = false;
                    if( typeof data.live_raffle !== 'undefined'){
                        $('#rdp_life_raffle').prop('checked', data.live_raffle );
                        lRec = true;
                    }                        
                    if( typeof data.count_start_at  !== 'undefined'){
                        $('#rdp_ticket_start_count_at').val( data.count_start_at );
                        lRec = true;
                    }

                    if( typeof data.last_live_ticket !== 'undefined'){
                        $('#liveLastTicketNo').val( data.last_live_ticket);
                        lRec = true; 
                    }


                    if( lRec )
                      $( '.bmp-pins-new-panel .panel-heading').bmp_message( rpwoo_local_lng.saved, 'success' );
                              
                } catch (error) {
                    $( '.bmp-pins-new-panel .panel-heading').bmp_message( rpwoo_local_lng.error_parsing_data, 'danger' ); 
                }            

            },
            error: function( request, status, error ){
             
                alert( 'Request ' + request + ' - Status: ' + status + ' - Error: ' + error);    
            },
            complete: function(){
                $('#drpLoaderImg').hide();
            }
        })
    }

    function rpwoo_fixDB(){
        $('#drpLoaderImg').show();
        var data_ajax = {
            action: 'drp_fix_db',
            type: 'POST',
            data: 'fix_db',
            dataType: 'json', 
            contentType: 'application/json'
        }

        $.ajax({
            type: 'POST',
            url: ajaxurl,
            data: data_ajax,
            beforeSend: function(){              
            }, 
            success: function(data){                           
                
                if( data == 'changed'){
                    window.location.reload();
                }
                $('#drpLoaderImg').hide();
            },
            error: function( request, status, error ){
            },
            complete: function(){               
            }
        })
    }
})(this.jQuery);